import { AppTracker } from './AppTracker';
import { ISignal } from '@lumino/signaling';
import { Machines } from './Machines';
import { Page } from '../components/deploy/RequirementsBar';
export declare class User {
    static handleLogin(responseData: any): User;
    private _deploySubMenuChanged;
    get deploySubMenuChanged(): ISignal<this, User>;
    private _selectedSettingsSubMenuChanged;
    get selectedSettingsSubMenuChanged(): ISignal<this, User>;
    private _unsignedAgreement;
    private _name;
    private _intent;
    private _userBudget;
    private _maxBudget;
    private _budgetCap;
    private _userRate;
    private _maxRate;
    private _rateCap;
    private _userAggregateRate;
    private _maxAggregateRate;
    private _aggregateRateCap;
    private _userHoldoverTime;
    private _maxHoldoverTime;
    private _holdoverTimeCap;
    private _userRecommendations;
    private _maxRecommendations;
    private _recommendationsCap;
    private _maxJobs;
    private _jobsCap;
    private _maxMachines;
    private _machinesCap;
    private _userExpertise;
    private _proactiveUploadsEnabled;
    private _compressFilesEnabled;
    private _lastPage;
    private _stopJobPreventEnabled;
    private _deleteJobPreventEnabled;
    private _noRequirementsPreventEnabled;
    private _noFileUploadsPreventEnabled;
    private _startSessionPreventEnabled;
    private _appTracker;
    private _machines;
    private _deploySubMenu;
    constructor(unsignedAgreement: boolean, name: string, intent: number, userBudget: number, maxBudget: number, budgetCap: number, userRate: number, maxRate: number, rateCap: number, userAggregateRate: number, maxAggregateRate: number, aggregateRateCap: number, userHoldoverTime: number, maxHoldoverTime: number, holdoverTimeCap: number, userRecommendations: number, maxRecommendations: number, recommendationsCap: number, maxJobs: number, jobsCap: number, maxMachines: number, machinesCap: number, userExpertise: number, proactiveUploadsEnabled: boolean, compressFilesEnabled: boolean, lastPage: number, stopJobPreventEnabled: boolean, deleteJobPreventEnabled: boolean, noRequirementsPreventEnabled: boolean, noFileUploadsPreventEnabled: boolean, startSessionPreventEnabled: boolean, appTracker: AppTracker, machines: Machines);
    get unsignedAgreement(): boolean;
    set unsignedAgreement(unsignedAgreement: boolean);
    get name(): string;
    set name(name: string);
    get deploySubMenu(): Page;
    set deploySubMenu(deploySubMenu: Page);
    get intent(): number;
    set intent(intent: number);
    get userBudget(): number;
    set userBudget(userBudget: number);
    get maxBudget(): number;
    set maxBudget(maxBudget: number);
    get budgetCap(): number;
    get userRate(): number;
    set userRate(userRate: number);
    get maxRate(): number;
    set maxRate(maxRate: number);
    get rateCap(): number;
    get userAggregateRate(): number;
    set userAggregateRate(userAggregateRate: number);
    get maxAggregateRate(): number;
    set maxAggregateRate(maxAggregateRate: number);
    get aggregateRateCap(): number;
    get userHoldoverTime(): number;
    set userHoldoverTime(userHoldoverTime: number);
    get maxHoldoverTime(): number;
    set maxHoldoverTime(maxHoldoverTime: number);
    get holdoverTimeCap(): number;
    get userRecommendations(): number;
    set userRecommendations(userRecommendations: number);
    get maxRecommendations(): number;
    set maxRecommendations(maxRecommendations: number);
    get recommendationsCap(): number;
    get maxJobs(): number;
    set maxJobs(maxJobs: number);
    get jobsCap(): number;
    get maxMachines(): number;
    set maxMachines(maxMachines: number);
    get machinesCap(): number;
    get userExpertise(): number;
    set userExpertise(userExpertise: number);
    get proactiveUploadsEnabled(): boolean;
    set proactiveUploadsEnabled(proactiveUploadsEnabled: boolean);
    get compressFilesEnabled(): boolean;
    set compressFilesEnabled(compressFilesEnabled: boolean);
    get lastPage(): number;
    set lastPage(lastPage: number);
    get stopJobPreventEnabled(): boolean;
    set stopJobPreventEnabled(stopJobPreventEnabled: boolean);
    get deleteJobPreventEnabled(): boolean;
    set deleteJobPreventEnabled(deleteJobPreventEnabled: boolean);
    get noRequirementsPreventEnabled(): boolean;
    set noRequirementsPreventEnabled(noRequirementsPreventEnabled: boolean);
    get noFileUploadsPreventEnabled(): boolean;
    set noFileUploadsPreventEnabled(noFileUploadsPreventEnabled: boolean);
    get startSessionPreventEnabled(): boolean;
    set startSessionPreventEnabled(startSessionPreventEnabled: boolean);
    get appTracker(): AppTracker;
    set machines(machines: Machines);
    get machines(): Machines;
    synchronize(responseData: any): void;
    private setUserInformation;
    changePassword(loginName: string, oldPassword: string, newPassword: string): Promise<void>;
}
